
//	WM_APP  0x8000
#define	SM_DATA_READY				WM_APP+1
#define	SM_ERROR_SYSTEM				WM_APP+2
#define	SM_ERROR_API				WM_APP+3

// WM_USER 0x0400
#define ERR_WRITE_FAIL				WM_USER+1
#define ERR_SETTING_FAIL			WM_USER+2
#define ERR_SCANNER_NOT_OPEN		WM_USER+3
#define ERR_INVALID_FILE			WM_USER+4
#define ERR_TIMEOUT					WM_USER+5
#define ERR_INVALID_SCANNER_VER		WM_USER+6

// Barcode Type
#define BC_CODE11					100
#define BC_CODE39					101
#define BC_CODE93					102
#define BC_CODE128				103
#define BC_CODABAR				104
#define	BC_EAN8						105
#define	BC_EAN13						106
#define	BC_INDUSTRIAL_25	107
#define	BC_INTERLEAVED_25	108
#define	BC_STANDARD_25		109
#define	BC_MSI_PLESSEY		110
#define	BC_UK_PLESSEY			111
#define	BC_TELEPEN					112
#define	BC_UPCA						113
#define	BC_UPCE						114
#define	BC_MATRIX_25			115
#define	BC_PDF417					116
#define	BC_CODE16K				117
#define	BC_CHINAPOST			118
#define	BC_RSS14						119
#define	BC_RSS_LIMITED			120
#define	BC_RSS_EXPANDED	121
#define	BC_PHARMACODE		122
#define	BC_MICOR_PDF			123
#define	BC_EANUCC 				124

struct GeneralSetting
{
	UINT	m_uiScanResume;

	UINT	m_uiLED;
	UINT	m_uiBeep;
	UINT	m_uiVibrator;

	UINT	m_uiPosition;
	UINT	m_uiTransmit;
	UINT	m_uiLengthTrans;
	UINT	m_uiNameTrans;
	UINT	m_uiConversion;

	UINT	m_uiConfirm;
	UINT	m_uiMinLength;
	UINT	m_uiMaxLength;
	UINT	m_uiInverte;
	
	unsigned char	m_strTerminator[22];
	unsigned char	m_strPreamble[22];
	unsigned char	m_strPostamble[22];
};

struct GeneralSetting_V1
{
	UINT	m_uiScanResume;

	UINT	m_uiLED;
	UINT	m_uiBeep;
	UINT	m_uiVibrator;

	UINT	m_uiPosition;
	UINT	m_uiTransmit;
	UINT	m_uiLengthTrans;
	UINT	m_uiNameTrans;
	UINT	m_uiConversion;

	UINT	m_uiScanMode;
	UINT	m_uiStandbyDuration;
	UINT	m_uiConfirm;
	UINT	m_uiMinLength;
	UINT	m_uiMaxLength;
	UINT	m_uiInverte;
	UINT	m_uiStandMode;
	
	unsigned char	m_strTerminator[22];
	unsigned char	m_strPreamble[22];
	unsigned char	m_strPostamble[22];
};

struct Code11_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct Code39_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiFormat;
	UINT		m_uiStarEndTrans;
};

struct Code93_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct Code128_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiFormat;
	unsigned char			m_cUCCEAN128ID;
	unsigned char			m_cConcatenationCode;
};

struct Codabar_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiStartEndType;
	UINT		m_uiStartEndTrans;
};

struct EAN8_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumTrans;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiSupplement;
	UINT		m_uiTruncation;
	UINT		m_uiExpansion;
};

struct EAN13_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumTrans;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiSupplement;
	UINT		m_uiISBN_ISSN;
};

struct Industrial25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct Interleaved25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct Standard25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct MSI_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct UK_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct Telepen_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiFormat;
};

struct UPCA_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumTrans;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiSupplement;
	UINT		m_uiTruncate;
};

struct UPCE_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumTrans;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiSupplement;
	UINT		m_uiTruncate;
	UINT		m_uiExpansion;
	UINT		m_uiUPCE1;
};

struct Matrix25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChecksumEnable;
	UINT		m_uiChecksumTrans;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct ChinaPost_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct RSS14_Setting
{
	UINT		m_uiRead;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiUCCEAN128_Emulation;
};

struct RSSLimited_Setting
{
	UINT		m_uiRead;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiUCCEAN128_Emulation;
};

struct RSSExpanded_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiUCCEAN128_Emulation;
};

struct Pharmacode_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiLeadingA;
};

struct PDF417_Setting
{
	UINT		m_uiRead;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiEscapeTrans;
};

struct Code16K_Setting
{
	UINT		m_uiRead;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
};

struct MicroPDF_Setting
{
	UINT		m_uiRead;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiEscapeTrans;
};

struct EANUCC_Setting
{
	UINT		m_uiRead;
	UINT		m_uiTruncateLeading;
	UINT		m_uiTruncateEnd;
	unsigned char			m_cID[2];
	UINT		m_uiUCCEAN128Emulation;
};

struct ScannerSetting
{
	struct GeneralSetting				generalsetting;
	struct Code11_Setting				Code11;
	struct Code39_Setting				Code39;
	struct Code93_Setting				Code93;
	struct Code128_Setting				Code128;
	struct Codabar_Setting				Codabar;
	struct EAN8_Setting					EAN8;
	struct EAN13_Setting				EAN13;
	struct Industrial25_Setting			Indust25;
	struct Interleaved25_Setting		Inter25;
	struct Standard25_Setting			Stand25;
	struct MSI_Setting					MSIPlessey;
	struct UK_Setting					UKPlessey;
	struct Telepen_Setting				Telepen;
	struct UPCA_Setting					UPCA;
	struct UPCE_Setting					UPCE;
	struct Matrix25_Setting				Matrix25;
	struct ChinaPost_Setting			ChinaPost;
	struct RSS14_Setting				Rss14;
	struct RSSLimited_Setting			RssLimited;
	struct RSSExpanded_Setting			RssExpanded;
	struct Pharmacode_Setting			Pharmacode;
	struct PDF417_Setting				PDF417;
	struct Code16K_Setting				Code16K;
	struct MicroPDF_Setting				MicroPDF;
	struct EANUCC_Setting				EANUCC;
};

struct ScannerSetting_V1
{
	struct GeneralSetting_V1			generalsetting;
	struct Code11_Setting				Code11;
	struct Code39_Setting				Code39;
	struct Code93_Setting				Code93;
	struct Code128_Setting				Code128;
	struct Codabar_Setting				Codabar;
	struct EAN8_Setting					EAN8;
	struct EAN13_Setting				EAN13;
	struct Industrial25_Setting			Indust25;
	struct Interleaved25_Setting		Inter25;
	struct Standard25_Setting			Stand25;
	struct MSI_Setting					MSIPlessey;
	struct UK_Setting					UKPlessey;
	struct Telepen_Setting				Telepen;
	struct UPCA_Setting					UPCA;
	struct UPCE_Setting					UPCE;
	struct Matrix25_Setting				Matrix25;
	struct ChinaPost_Setting			ChinaPost;
	struct RSS14_Setting				Rss14;
	struct RSSLimited_Setting			RssLimited;
	struct RSSExpanded_Setting			RssExpanded;
	struct Pharmacode_Setting			Pharmacode;
	struct PDF417_Setting				PDF417;
	struct Code16K_Setting				Code16K;
	struct MicroPDF_Setting				MicroPDF;
	struct EANUCC_Setting				EANUCC;
};

int GetLibraryVersion();

BOOL API_Register(HWND hwnd);
BOOL API_Register2(HANDLE hHandle, int *pMessage);
void API_Unregister();

BOOL API_Reset();
DWORD	API_GetError();
DWORD	API_GetSysError();
UINT API_GetBarData(LPBYTE buffer, UINT *uiLength, UINT *uiBarType);
UINT API_GetBarDataLength();
UINT API_GetBarType();
void API_ResetBarData();
void API_GoodRead();

BOOL API_SaveSettingsToScanner();
BOOL API_SaveSettingsToFile(LPCTSTR filename);
BOOL API_LoadSettingsFromFile(LPCTSTR filename);

BOOL S2K_IsLoad();
BOOL S2K_Load(BOOL bLoad, DWORD dwTimeOut);

BOOL SCAN_SendCommand(int nCommand1, int nCommand2, char *pValue);
BOOL SCAN_QueryStatus(int nCommand1, int nCommand2, char *pReturn);
DWORD	SCAN_BatchSetting(ScannerSetting setting);
DWORD	SCAN_BatchRead(ScannerSetting *ReadBuf);
DWORD	SCAN_EnablePowerOnAlert(int nEnable);
int SCAN_GetPowerOnAlert();
DWORD	SCAN_BatchSetting_V1(ScannerSetting_V1 setting);
DWORD	SCAN_BatchRead_V1(ScannerSetting_V1 *ReadBuf);

DWORD	EnableTriggerKey(BOOL bEnable);
DWORD	GetTriggerKeyStatus();
DWORD	TriggerStatus();
DWORD	PressTriggerKey(BOOL bPress);
DWORD	SCAN_ResumeSystem(BOOL bOn);
DWORD	GetScannerDevice();

BOOL PT_OpenScan2Key();
void PT_CloseScan2Key();
int PT_SetToDefault();

int PT_EnableScanner();
void PT_DisableScanner();
BOOL PT_CheckBarcodeData();
BOOL PT_GetBarcodeData(UINT *uiBarType, char *pBuffer, UINT *uiMaxBufferLen);
BOOL PT_SetDefault();
